!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SXINM2(MM,NM,JM,IG,P,R,JC,MI)

  IMPLICIT NONE
  INTEGER(8) :: MM,NM,JM,IG,M,IE,IJ,MI,K
  REAL(8) :: P(JM/2,5+2*(MM/MI+1))
  REAL(8) :: R(5*(MM/MI+1)*(2*NM-MM/MI*MI)/4+MM/MI+1)
  INTEGER(8) :: JC((MM/MI+1)*(2*NM-MM/MI*MI)/16+MM/MI+1)
  INTEGER(8) :: NPMAX  
  INTEGER(8) :: N1,M1,MN  

  N1=MM/MI+1
  M1=N1*MI
  MN=N1
  IF(MM/MI-M1/MI.GE.0) THEN
     MN=MN+1
  END IF

  CALL LXINIG(JM,P,IG)

  CALL MXGOMP(NPMAX)  

!$omp parallel private(K,M,IE,IJ) num_threads(NPMAX)
!$omp do schedule(dynamic)
  DO K=0,MN-1
     IE=5*K*(2*NM-MI*(K-1))/4+K+1 ! サイズを変えたのでこうなる
     IJ=K*(2*NM-MI*(K-1))/16+K+1
     M=K*MI
     IF(M.NE.0) THEN     
        CALL LXINIW(NM,JM,M,P,P(1,5+2*K+1),R(IE),JC(IJ))
     END IF
  END DO
!$omp end do
!$omp end parallel  
  
END SUBROUTINE SXINM2

